Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.fourthline.cling.model.meta
Class LocalDevice

    java.lang.Object
      org.fourthline.cling.model.meta.Device<DeviceIdentity,LocalDevice,LocalService>
          org.fourthline.cling.model.meta.LocalDevice

All Implemented Interfaces:
  Validatable

    public class LocalDevice

extends Device<DeviceIdentity,LocalDevice,LocalService>

The metadata of a device created on this host, by application code.

Author:
  Christian Bauer

Field Summary

Fields inherited from class org.fourthline.cling.model.meta.Device
`embeddedDevices, services`

Constructor Summary
`LocalDevice(DeviceIdentity identity)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, LocalService service)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, LocalService[] services)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, LocalService[] services, LocalDevice[] embeddedDevices)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, LocalService service, LocalDevice embeddedDevice)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, LocalService service)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, LocalService[] services)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, LocalService[] services, LocalDevice[] embeddedDevices)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, LocalService service, LocalDevice embeddedDevice)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, LocalService service)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, LocalService[] services)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, LocalService[] services, LocalDevice[] embeddedDevices)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetails details, LocalService service, LocalDevice embeddedDevice)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetailsProvider deviceDetailsProvider, Icon[] icons, LocalService service, LocalDevice embeddedDevice)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetailsProvider deviceDetailsProvider, Icon icon, LocalService[] services)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetailsProvider deviceDetailsProvider, LocalService service)`
`LocalDevice(DeviceIdentity identity, DeviceType type, DeviceDetailsProvider deviceDetailsProvider, LocalService service, LocalDevice embeddedDevice)`
`LocalDevice(DeviceIdentity identity, UDAVersion version, DeviceType type, DeviceDetails details, Icon[] icons, LocalService[] services, LocalDevice[] embeddedDevices)`
`LocalDevice(DeviceIdentity identity, UDAVersion version, DeviceType type, DeviceDetailsProvider deviceDetailsProvider, Icon[] icons, LocalService[] services, LocalDevice[] embeddedDevices)`

Method Summary
`Resource[]` | `discoverResources(Namespace namespace)`
`LocalDevice` | `findDevice(UDN udn)`
`DeviceDetails` | `getDetails(RemoteClientInfo info)`
`DeviceDetailsProvider` | `getDeviceDetailsProvider()`
`LocalDevice[]` | `getEmbeddedDevices()`
`LocalDevice` | `getRoot()`
`LocalService[]` | `getServices()`
`LocalService` | `newInstance(ServiceType serviceType, ServiceId serviceId, URI descriptorURI, URI controlURI, URI eventSubscriptionURI, Action<LocalService>[] actions, StateVariable<LocalService>[] stateVariables)`
`LocalDevice` | `newInstance(UDN udn, UDAVersion version, DeviceType type, DeviceDetails details, Icon[] icons, LocalService[] services, List<LocalDevice> embeddedDevices)`
`LocalService[]` | `newServiceArray(int size)`
`LocalDevice[]` | `toDeviceArray(Collection<LocalDevice> col)`
`LocalService[]` | `toServiceArray(Collection<LocalService> col)`
`List<ValidationError>` | `validate()`

Methods inherited from class org.fourthline.cling.model.meta.Device
`equals, find, find, find, findDevices, findDevices, findEmbeddedDevices, findEmbeddedDevices, findIcons, findService, findService, findServices, findServices, findServices, findServiceTypes, getDetails, getDisplayString, getIcons, getIdentity, getParentDevice, getType, getVersion, hasEmbeddedDevices, hashCode, hasIcons, hasServices, isFullyHydrated, isRoot, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LocalDevice

    public LocalDevice(DeviceIdentity identity)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       LocalService service)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetailsProvider deviceDetailsProvider,
                       LocalService service)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetailsProvider deviceDetailsProvider,
                       LocalService service,
                       LocalDevice embeddedDevice)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       LocalService service,
                       LocalDevice embeddedDevice)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       LocalService[] services)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       LocalService[] services,
                       LocalDevice[] embeddedDevices)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon icon,
                       LocalService service)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon icon,
                       LocalService service,
                       LocalDevice embeddedDevice)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon icon,
                       LocalService[] services)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetailsProvider deviceDetailsProvider,
                       Icon icon,
                       LocalService[] services)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon icon,
                       LocalService[] services,
                       LocalDevice[] embeddedDevices)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon[] icons,
                       LocalService service)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon[] icons,
                       LocalService service,
                       LocalDevice embeddedDevice)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetailsProvider deviceDetailsProvider,
                       Icon[] icons,
                       LocalService service,
                       LocalDevice embeddedDevice)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon[] icons,
                       LocalService[] services)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       DeviceType type,
                       DeviceDetails details,
                       Icon[] icons,
                       LocalService[] services,
                       LocalDevice[] embeddedDevices)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       UDAVersion version,
                       DeviceType type,
                       DeviceDetails details,
                       Icon[] icons,
                       LocalService[] services,
                       LocalDevice[] embeddedDevices)
                throws ValidationException

Throws:
  `ValidationException`

### LocalDevice

    public LocalDevice(DeviceIdentity identity,
                       UDAVersion version,
                       DeviceType type,
                       DeviceDetailsProvider deviceDetailsProvider,
                       Icon[] icons,
                       LocalService[] services,
                       LocalDevice[] embeddedDevices)
                throws ValidationException

Throws:
  `ValidationException`

Method Detail

### getDeviceDetailsProvider

    public DeviceDetailsProvider getDeviceDetailsProvider()

### getDetails

    public DeviceDetails getDetails(RemoteClientInfo info)

  Overrides:
    `getDetails` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### getServices

    public LocalService[] getServices()

  Specified by:
    `getServices` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### getEmbeddedDevices

    public LocalDevice[] getEmbeddedDevices()

  Specified by:
    `getEmbeddedDevices` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### newInstance

    public LocalDevice newInstance(UDN udn,
                                   UDAVersion version,
                                   DeviceType type,
                                   DeviceDetails details,
                                   Icon[] icons,
                                   LocalService[] services,
                                   List<LocalDevice> embeddedDevices)
                            throws ValidationException

  Specified by:
    `newInstance` in class `Device<DeviceIdentity,LocalDevice,LocalService>`
  Throws:
    `ValidationException`

### newInstance

    public LocalService newInstance(ServiceType serviceType,
                                    ServiceId serviceId,
                                    URI descriptorURI,
                                    URI controlURI,
                                    URI eventSubscriptionURI,
                                    Action<LocalService>[] actions,
                                    StateVariable<LocalService>[] stateVariables)
                             throws ValidationException

  Specified by:
    `newInstance` in class `Device<DeviceIdentity,LocalDevice,LocalService>`
  Throws:
    `ValidationException`

### toDeviceArray

    public LocalDevice[] toDeviceArray(Collection<LocalDevice> col)

  Specified by:
    `toDeviceArray` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### newServiceArray

    public LocalService[] newServiceArray(int size)

  Specified by:
    `newServiceArray` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### toServiceArray

    public LocalService[] toServiceArray(Collection<LocalService> col)

  Specified by:
    `toServiceArray` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### validate

    public List<ValidationError> validate()

  Specified by:
    `validate` in interface `Validatable`
  Overrides:
    `validate` in class `Device<DeviceIdentity,LocalDevice,LocalService>`
  Returns:
    An empty `List` if all rules validated properly, otherwise, the detected errors.

### discoverResources

    public Resource[] discoverResources(Namespace namespace)

  Specified by:
    `discoverResources` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### getRoot

    public LocalDevice getRoot()

  Specified by:
    `getRoot` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

### findDevice

    public LocalDevice findDevice(UDN udn)

  Specified by:
    `findDevice` in class `Device<DeviceIdentity,LocalDevice,LocalService>`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2013 4th Line GmbH, Switzerland. All Rights Reserved.